=== debian/changelog ===
soqt (1.6.0+ds1-3) unstable; urgency=medium

  * Reuploaded with sources. Should fix FTBFS. 

 -- Anton Gladky <gladk@debian.org>  Sun, 28 Jun 2020 22:40:49 +0200

soqt (1.6.0+ds1-2) unstable; urgency=medium

  * Team upload.
  * [8ffc47f] Minor fix in .gitlab-ci.yml
  * [e129167] Fix autopkgtests. (Closes: #963837)
  * [0d3fc58] Fix wrong license short name. (Closes: #963840)
  * [da0cfe8] Set upstream metadata fields: Bug-Database, Bug-Submit.
  * [031fa0b] Rely on pre-initialized dpkg-architecture variables.
  * [b78d0ba] Apply cme fix dpkg

 -- Anton Gladky <gladk@debian.org>  Sun, 28 Jun 2020 19:19:58 +0200

soqt (1.6.0+ds1-1) unstable; urgency=medium

  [ Kurt Kremitzki ]
  * [ef61908] Update d/watch to new Github upstream
  * [8c2ec13] Update homepage
  * [ea9d821] Temporarily disable test03
  * [53eab82] Update to Standards-Version 4.4.1 & debhelper compat 12
  * [8dbb52c] Remove debian/source/include-binaries
  * [95ef6fb] Refresh 0004-Drop-use-of-CPack.patch
  * [61acb64] Refresh 0002-Adding-Qt-major-version-to-Soname.patch
  * [68daeca] Refresh 0003-Fix-LIBRARY_DIRS.patch
  * [078cca8] Remove upstreamed 0004-Patch-adding-VERSION.patch
  * [4552846] Add myself to Uploaders
  * [7a50ce0] Update autopkgtest to not use soqt-config
  * [1b76ee9] Add material headers to dev package
  * [374ce70] New upstream version 1.6.0+ds

  [ Leopold Palomo-Avellaneda ]
  * [1ec719f] New version with components
  * [6f89d89] Added repack
  * [2257fa7] New upstream version 1.6.0+ds1
  * [1fca5a0] Update standards. No changes

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 27 Apr 2020 16:18:20 +0200
