=== debian/control ===
Source: soqt
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>,
           Kurt Kremitzki <kurt@kwk.systems>
Section: graphics
Priority: optional
Build-Depends: debhelper-compat (= 12),
               doxygen,
               cmake,
               libcoin-dev,
               qtbase5-dev,
               libqt5opengl5-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/soqt
Vcs-Git: https://salsa.debian.org/science-team/soqt.git
Homepage: https://github.com/coin3d/soqt
Rules-Requires-Root: no

Package: libsoqt520
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Qt5 GUI component toolkit for Inventor - runtime
 SoQt is a Qt GUI component toolkit library for Coin, based on the
 API of the InventorXt GUI component toolkit.  SoQt is also compatible
 with OpenInventor of SGI and TGS.
 .
 This library is linked against Qt version 5.

Package: libsoqt520-dev
Architecture: any
Section: libdevel
Depends: libcoin-dev,
         libqt5opengl5-dev,
         libsoqt520 (= ${binary:Version}),
         qtbase5-dev,
         ${misc:Depends}
Breaks: libsoqt-dev-common,
        libsoqt4-dev
Provides: libsoqt-dev
Replaces: libsoqt-dev-common,
          libsoqt4-dev
Description: Qt5 GUI component toolkit for Inventor - development
 SoQt is a Qt GUI component toolkit library for Coin, based on the
 API of the InventorXt GUI component toolkit.  SoQt is also compatible
 with OpenInventor of SGI and TGS.
 .
 SoQt provides a class-hierarchy of viewer classes that ranges from a
 simple render canvas (the SoQtRenderArea), providing only the basic
 synchronization and device input conversion routines between Qt and
 Coin, up to 3 different full-featured viewer classes
 (SoQtExaminerViewer, SoQtPlaneViewer and SoQtFlyViewer) with input
 device handling logic and user interfaces to let the application
 programmer do Rapid Application Development.
 .
 This library is linked against Qt version 5.
