=== debian/tests/control ===
# Temporarily disabling test03
Tests: test01 test02 test04 test05
Depends: @, build-essential, xvfb, xauth, libxcursor1
